/*

Copyright (c) 2012 Red Hat Incorporated.
All rights reserved.

Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions are met: 

    Redistributions of source code must retain the above copyright 
    notice, this list of conditions and the following disclaimer.

    Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

    The name of Red Hat Incorporated may not be used to endorse 
    or promote products derived from this software without specific 
    prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED.  IN NO EVENT SHALL RED HAT INCORPORATED BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND 
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 

*/

#include "vregs.h"
	
	.text

	.global	_memset
	.type	_memset, @function
_memset:
	;; [sp+4].HI = dest
	;; [sp+6].HI = val
	;; [sp+8].HI = count

	movw	ax, [sp+4]
	movw	hl, ax
	movw	ax, [sp+8]
	movw	bc, ax

	mov	a, l
	bf	a.0, $ptr_aligned
	mov	a, [sp+6]
	mov	[hl], a
	incw	hl
	decw	bc
ptr_aligned:

	movw	ax, bc
	movw	de, ax
	shrw	ax, 1
	movw	bc, ax
	mov	a, [sp+6]
	mov	x, a

	;; increment B and C as we branch on zero, not carry
	inc	b
	inc	c
	br	$wbot
wtop:
	movw	[hl], ax
	incw	hl
	incw	hl

wbot:	
	dec	c
	bnz	$wtop
	dec	b
	bnz	$wtop

	mov	a, e
	bf	a.0, $no_last_byte

	mov	a, [sp+6]
	mov	[hl], a
	
no_last_byte:	

	movw	ax, [sp+4]
	movw	r8, ax
	ret

	.size	_memset, .-_memset
