/*

Copyright (c) 2012 Red Hat Incorporated.
All rights reserved.

Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions are met: 

    Redistributions of source code must retain the above copyright 
    notice, this list of conditions and the following disclaimer.

    Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

    The name of Red Hat Incorporated may not be used to endorse 
    or promote products derived from this software without specific 
    prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED.  IN NO EVENT SHALL RED HAT INCORPORATED BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND 
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 

*/

#include "vregs.h"
	
	.text

	.global	_strcmp
	.type	_strcmp, @function
_strcmp:
	;; [sp+4].HI = dest
	;; [sp+6].HI = src

	movw	ax, [sp+4]
	movw	de, ax
	movw	ax, [sp+6]
	movw	hl, ax

Ltop:	
	.macro	one_iter
	mov	a, [de]
	cmp	a, [hl]
	bnz	$Lmismatch
	cmp0	a
	bz	$Lend
	incw	de
	incw	hl
	.endm

	one_iter
	one_iter
	one_iter
	one_iter

	br	$Ltop

Lend:
	movw	r8, #0
	ret

Lmismatch:
	sub	a, [hl]
	mov	r8, a
	sar	a, 7
	mov	r9, a
	ret
	
	.size	_strcmp, .-_strcmp

